var path		= require('path');
var express		= require('express');
var bodyParser	= require('body-parser');
var open		= require('open');
var portfinder	= require('portfinder');

var login = function(callback) {
	portfinder.getPort(function (err, port) {
		if (err) throw(err);
		var app = express();
		var urlencodedParser = bodyParser.urlencoded({ extended: false })
		
		// show local login page
		app.use('/', express.static(path.join(__dirname, '..', 'www')));
		
		// catch login post message
		app.post('/', urlencodedParser, function(req, res) {
			
			// set access token and refresh token
			lib.settings.accessToken = req.body.accessToken;
			lib.settings.refreshToken = req.body.refreshToken;
			
			// get user info
			lib.api.call({
				path: '/auth/me'
			}, function(err, result, body){
				if (err) throw(err);
				
				// save user info
				lib.settings.user = body;
				
				// send OK to browser
				res.send('OK');
				
				// show name in console
				console.log(("Welcome, " + body.firstname + '! You are now logged in to FORMIDE.').green);
			
				// callback
				if (typeof callback == 'function') {
					callback();
				}
				else {
					setTimeout(process.exit, 1000);
				}
			});
		});
		
		// listen to free port
		app.listen(port);
		
		// open local login page in browser
		var address = "http://localhost:" + port;
		console.log("Opening auth page at " + address);
		open(address);
	});
};

var me = function(callback) {
	console.log(lib.settings.user);	
};

var logout = function(callback) {
	delete lib.settings.accessToken;
	delete lib.settings.refreshToken;
	delete lib.settings.user;
	setTimeout(process.exit, 1000);
};

module.exports.login = login;
module.exports.logout = logout;
module.exports.me = me;