var myApp = function() {
    
    // The init function of a registered plugin is called
    // when the SDK is fully loaded
    this.init = function() {
        FormideSDK.showPrintBed(true, 'xyz');
        FormideSDK.setBackgroundColor( 220, 220, 220 );
        FormideSDK.setSelectionIntensity( 0.2 );
    	FormideSDK.addModel('./assets/cube40mm.stl', function(response) {
        	FormideSDK.setModelColor(response.data.newId, 200, 200, 100);
    	});
    	
    	// Require and external file like your app config
    	// using a relative path to the javascript file
    	FormideSDK.require('app.json', function(config) {
        	console.log(JSON.parse(config));
    	});
    }
    
    // This function is used by the event listerer as seen below
    this.handleSelected = function(event) {
  		console.log(event);  
    };
    
    // You can listen to events from the SDK like when a model
    // is selected. Then, you can tie a custom function to it
    FormideSDK.on('modelSelected', this.handleSelected);
};
// Register a new instance of your app
FormideSDK.registerApp(new myApp());